diff --git a/gcc/lto/lto-symtab.c b/gcc/lto/lto-symtab.c
index 71242c8..12a0bb8 100644
--- a/gcc/lto/lto-symtab.c
+++ b/gcc/lto/lto-symtab.c
@@ -243,7 +243,7 @@ lto_symtab_resolve_replaceable_p (symtab_node *e)
 
   if (TREE_CODE (e->decl) == VAR_DECL)
     return (DECL_COMMON (e->decl)
-	    || (!flag_no_common && !DECL_INITIAL (e->decl)));
+	    || (!GCC_OPTION (flag_no_common) && !DECL_INITIAL (e->decl)));
 
   return false;
 }
@@ -584,7 +584,7 @@ lto_symtab_merge_symbols (void)
 {
   symtab_node *node;
 
-  if (!flag_ltrans)
+  if (!GCC_OPTION (flag_ltrans))
     {
       symtab_initialize_asm_name_hash ();
 
diff --git a/gcc/lto/lto.c b/gcc/lto/lto.c
index df9f031..94e1b6a 100644
--- a/gcc/lto/lto.c
+++ b/gcc/lto/lto.c
@@ -1896,7 +1896,7 @@ lto_read_decls (struct lto_file_decl_data *decl_data, const void *data,
 	    continue;
 
 	  /* Try to unify the SCC with already existing ones.  */
-	  if (!flag_ltrans
+	  if (!GCC_OPTION (flag_ltrans)
 	      && unify_scc (data_in->reader_cache, from,
 			    len, scc_entry_len, scc_hash))
 	    continue;
@@ -1934,10 +1934,10 @@ lto_read_decls (struct lto_file_decl_data *decl_data, const void *data,
 			(t, NULL_TREE, TREE_VALUE (attr), 0);
 		}
 	      /* Register TYPE_DECLs with the debuginfo machinery.  */
-	      if (!flag_wpa
+	      if (!GCC_OPTION (flag_wpa)
 		  && TREE_CODE (t) == TYPE_DECL)
 		debug_hooks->type_decl (t, !DECL_FILE_SCOPE_P (t));
-	      if (!flag_ltrans)
+	      if (!GCC_OPTION (flag_ltrans))
 		{
 		  /* Register variables and functions with the
 		     symbol table.  */
@@ -2560,7 +2560,7 @@ lto_wpa_write_files (void)
   size_t blen;
 
   /* Open the LTRANS output list.  */
-  if (!ltrans_output_list)
+  if (!GCC_OPTION (ltrans_output_list))
     fatal_error ("no LTRANS output list filename provided");
 
   timevar_push (TV_WHOPR_WPA);
@@ -2573,9 +2573,9 @@ lto_wpa_write_files (void)
   timevar_push (TV_WHOPR_WPA_IO);
 
   /* Generate a prefix for the LTRANS unit files.  */
-  blen = strlen (ltrans_output_list);
+  blen = strlen (GCC_OPTION (ltrans_output_list));
   temp_filename = (char *) xmalloc (blen + sizeof ("2147483648.o"));
-  strcpy (temp_filename, ltrans_output_list);
+  strcpy (temp_filename, GCC_OPTION (ltrans_output_list));
   if (blen > sizeof (".out")
       && strcmp (temp_filename + blen - sizeof (".out") + 1,
 		 ".out") == 0)
@@ -2588,8 +2588,8 @@ lto_wpa_write_files (void)
      FIXME: Even when not reordering we may want to output one list for parallel make
      and other for final link command.  */
 
-  if (!flag_profile_reorder_functions || !flag_profile_use)
-    ltrans_partitions.qsort (flag_toplevel_reorder
+  if (!GCC_OPTION (flag_profile_reorder_functions) || !GCC_OPTION (flag_profile_use))
+    ltrans_partitions.qsort (GCC_OPTION (flag_toplevel_reorder)
 			   ? cmp_partitions_size
 			   : cmp_partitions_order);
 
@@ -2600,7 +2600,7 @@ lto_wpa_write_files (void)
       /* Write all the nodes in SET.  */
       sprintf (temp_filename + blen, "%u.o", i);
 
-      if (!quiet_flag)
+      if (!GCC_OPTION (quiet_flag))
 	fprintf (stderr, " %s (%s %i insns)", temp_filename, part->name, part->insns);
       if (cgraph_dump_file)
 	{
@@ -2646,16 +2646,16 @@ lto_wpa_write_files (void)
 
       temp_filenames.safe_push (xstrdup (temp_filename));
     }
-  ltrans_output_list_stream = fopen (ltrans_output_list, "w");
+  ltrans_output_list_stream = fopen (GCC_OPTION (ltrans_output_list), "w");
   if (ltrans_output_list_stream == NULL)
-    fatal_error ("opening LTRANS output list %s: %m", ltrans_output_list);
+    fatal_error ("opening LTRANS output list %s: %m", GCC_OPTION (ltrans_output_list));
   for (i = 0; i < n_sets; i++)
     {
       unsigned int len = strlen (temp_filenames[i]);
       if (fwrite (temp_filenames[i], 1, len, ltrans_output_list_stream) < len
 	  || fwrite ("\n", 1, 1, ltrans_output_list_stream) < 1)
 	fatal_error ("writing to LTRANS output list %s: %m",
-		     ltrans_output_list);
+		     GCC_OPTION (ltrans_output_list));
      free (temp_filenames[i]);
     }
   temp_filenames.release();
@@ -2664,7 +2664,7 @@ lto_wpa_write_files (void)
 
   /* Close the LTRANS output list.  */
   if (fclose (ltrans_output_list_stream))
-    fatal_error ("closing LTRANS output list %s: %m", ltrans_output_list);
+    fatal_error ("closing LTRANS output list %s: %m", GCC_OPTION (ltrans_output_list));
 
   free_ltrans_partitions();
   free (temp_filename);
@@ -2947,14 +2947,14 @@ read_cgraph_and_symbols (unsigned nfiles, const char **fnames)
   for (i = 0; i < TI_MAX; ++i)
     lto_register_canonical_types (global_trees[i], false);
 
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "Reading object files:");
 
   /* Read all of the object files specified on the command line.  */
   for (i = 0, last_file_ix = 0; i < nfiles; ++i)
     {
       struct lto_file_decl_data *file_data = NULL;
-      if (!quiet_flag)
+      if (!GCC_OPTION (quiet_flag))
 	{
 	  fprintf (stderr, " %s", fnames[i]);
 	  fflush (stderr);
@@ -2989,7 +2989,7 @@ read_cgraph_and_symbols (unsigned nfiles, const char **fnames)
     fclose (resolution);
 
   /* Show the LTO report before launching LTRANS.  */
-  if (flag_lto_report || (flag_wpa && flag_lto_report_wpa))
+  if (GCC_OPTION (flag_lto_report) || (GCC_OPTION (flag_wpa) && GCC_OPTION (flag_lto_report_wpa)))
     print_lto_report_1 ();
 
   /* Free gimple type merging datastructures.  */
@@ -3006,7 +3006,7 @@ read_cgraph_and_symbols (unsigned nfiles, const char **fnames)
 
   timevar_pop (TV_IPA_LTO_DECL_IN);
 
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "\nReading the callgraph\n");
 
   timevar_push (TV_IPA_LTO_CGRAPH_IO);
@@ -3032,7 +3032,7 @@ read_cgraph_and_symbols (unsigned nfiles, const char **fnames)
   
   timevar_pop (TV_IPA_LTO_CGRAPH_IO);
 
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "Merging declarations\n");
 
   timevar_push (TV_IPA_LTO_DECL_MERGE);
@@ -3040,7 +3040,7 @@ read_cgraph_and_symbols (unsigned nfiles, const char **fnames)
      need to care about resolving symbols again, we only need to replace
      duplicated declarations read from the callgraph and from function
      sections.  */
-  if (!flag_ltrans)
+  if (!GCC_OPTION (flag_ltrans))
     {
       lto_symtab_merge_decls ();
 
@@ -3060,11 +3060,11 @@ read_cgraph_and_symbols (unsigned nfiles, const char **fnames)
   timevar_pop (TV_IPA_LTO_DECL_MERGE);
   /* Each pass will set the appropriate timer.  */
 
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "Reading summaries\n");
 
   /* Read the IPA summary data.  */
-  if (flag_ltrans)
+  if (GCC_OPTION (flag_ltrans))
     ipa_read_optimization_summaries ();
   else
     ipa_read_summaries ();
@@ -3111,9 +3111,9 @@ materialize_cgraph (void)
   struct cgraph_node *node; 
   timevar_id_t lto_timer;
 
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr,
-	     flag_wpa ? "Materializing decls:" : "Reading function bodies:");
+	     GCC_OPTION (flag_wpa) ? "Materializing decls:" : "Reading function bodies:");
 
   /* Now that we have input the cgraph, we need to clear all of the aux
      nodes and read the functions if we are not running in WPA mode.  */
@@ -3132,15 +3132,15 @@ materialize_cgraph (void)
 
   /* Start the appropriate timer depending on the mode that we are
      operating in.  */
-  lto_timer = (flag_wpa) ? TV_WHOPR_WPA
-	      : (flag_ltrans) ? TV_WHOPR_LTRANS
+  lto_timer = (GCC_OPTION (flag_wpa)) ? TV_WHOPR_WPA
+	      : (GCC_OPTION (flag_ltrans)) ? TV_WHOPR_LTRANS
 	      : TV_LTO;
   timevar_push (lto_timer);
 
   current_function_decl = NULL;
   set_cfun (NULL);
 
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "\n");
 
   timevar_pop (lto_timer);
@@ -3151,13 +3151,13 @@ materialize_cgraph (void)
 static void
 print_lto_report_1 (void)
 {
-  const char *pfx = (flag_lto) ? "LTO" : (flag_wpa) ? "WPA" : "LTRANS";
+  const char *pfx = (GCC_OPTION (flag_lto)) ? "LTO" : (GCC_OPTION (flag_wpa)) ? "WPA" : "LTRANS";
   fprintf (stderr, "%s statistics\n", pfx);
 
   fprintf (stderr, "[%s] read %lu SCCs of average size %f\n",
 	   pfx, num_sccs_read, total_scc_size / (double)num_sccs_read);
   fprintf (stderr, "[%s] %lu tree bodies read in total\n", pfx, total_scc_size);
-  if (flag_wpa && tree_scc_hash.is_created ())
+  if (GCC_OPTION (flag_wpa) && tree_scc_hash.is_created ())
     {
       fprintf (stderr, "[%s] tree SCC table: size %ld, %ld elements, "
 	       "collision ratio: %f\n", pfx,
@@ -3217,11 +3217,11 @@ do_whole_program_analysis (void)
   lto_parallelism = 1;
 
   /* TODO: jobserver communicatoin is not supported, yet.  */
-  if (!strcmp (flag_wpa, "jobserver"))
+  if (!strcmp (GCC_OPTION (flag_wpa), "jobserver"))
     lto_parallelism = -1;
   else
     {
-      lto_parallelism = atoi (flag_wpa);
+      lto_parallelism = atoi (GCC_OPTION (flag_wpa));
       if (lto_parallelism <= 0)
 	lto_parallelism = 0;
     }
@@ -3236,7 +3236,7 @@ do_whole_program_analysis (void)
   /* Reading in the cgraph uses different timers, start timing WPA now.  */
   timevar_push (TV_WHOPR_WPA);
 
-  if (pre_ipa_mem_report)
+  if (GCC_OPTION (pre_ipa_mem_report))
     {
       fprintf (stderr, "Memory consumption before IPA\n");
       dump_memory_report (false);
@@ -3266,9 +3266,9 @@ do_whole_program_analysis (void)
   timevar_pop (TV_WHOPR_WPA);
 
   timevar_push (TV_WHOPR_PARTITIONING);
-  if (flag_lto_partition_1to1)
+  if (GCC_OPTION (flag_lto_partition_1to1))
     lto_1_to_1_map ();
-  else if (flag_lto_partition_max)
+  else if (GCC_OPTION (flag_lto_partition_max))
     lto_max_map ();
   else
     lto_balanced_map ();
@@ -3294,26 +3294,26 @@ do_whole_program_analysis (void)
   ggc_collect ();
 
   timevar_start (TV_PHASE_STREAM_OUT);
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     {
       fprintf (stderr, "\nStreaming out");
       fflush (stderr);
     }
   lto_wpa_write_files ();
-  if (!quiet_flag)
+  if (!GCC_OPTION (quiet_flag))
     fprintf (stderr, "\n");
   timevar_stop (TV_PHASE_STREAM_OUT);
 
-  if (post_ipa_mem_report)
+  if (GCC_OPTION (post_ipa_mem_report))
     {
       fprintf (stderr, "Memory consumption after IPA\n");
       dump_memory_report (false);
     }
 
   /* Show the LTO report before launching LTRANS.  */
-  if (flag_lto_report || (flag_wpa && flag_lto_report_wpa))
+  if (GCC_OPTION (flag_lto_report) || (GCC_OPTION (flag_wpa) && GCC_OPTION (flag_lto_report_wpa)))
     print_lto_report_1 ();
-  if (mem_report_wpa)
+  if (GCC_OPTION (mem_report_wpa))
     dump_memory_report (true);
 }
 
@@ -3344,11 +3344,11 @@ lto_eh_personality (void)
 static void 
 lto_process_name (void)
 {
-  if (flag_lto)
+  if (GCC_OPTION (flag_lto))
     setproctitle ("lto1-lto");
-  if (flag_wpa)
+  if (GCC_OPTION (flag_wpa))
     setproctitle ("lto1-wpa");
-  if (flag_ltrans)
+  if (GCC_OPTION (flag_ltrans))
     setproctitle ("lto1-ltrans");
 }
 
@@ -3418,14 +3418,14 @@ lto_main (void)
       /* If WPA is enabled analyze the whole call graph and create an
 	 optimization plan.  Otherwise, read in all the function
 	 bodies and continue with optimization.  */
-      if (flag_wpa)
+      if (GCC_OPTION (flag_wpa))
 	do_whole_program_analysis ();
       else
 	{
 	  timevar_start (TV_PHASE_OPT_GEN);
 
 	  materialize_cgraph ();
-	  if (!flag_ltrans)
+	  if (!GCC_OPTION (flag_ltrans))
 	    lto_promote_statics_nonwpa ();
 
 	  /* Let the middle end know that we have read and merged all of
@@ -3439,7 +3439,7 @@ lto_main (void)
 	     print_lto_report before launching LTRANS.  If LTRANS was
 	     launched directly by the driver we would not need to do
 	     this.  */
-	  if (flag_lto_report || (flag_wpa && flag_lto_report_wpa))
+	  if (GCC_OPTION (flag_lto_report) || (GCC_OPTION (flag_wpa) && GCC_OPTION (flag_lto_report_wpa)))
 	    print_lto_report_1 ();
 	}
     }
diff --git a/gcc/mode-switching.c b/gcc/mode-switching.c
index 88543b2..c100d12 100644
--- a/gcc/mode-switching.c
+++ b/gcc/mode-switching.c
@@ -295,7 +295,7 @@ create_pre_exit (int n_entities, int *entity_map, const int *num_modes)
 			return_copy_pat = PATTERN (return_copy);
 			if (GET_CODE (return_copy_pat) != CLOBBER)
 			  break;
-			else if (!optimize)
+			else if (!GCC_OPTION (optimize))
 			  {
 			    /* This might be (clobber (reg [<result>]))
 			       when not optimizing.  Then check if
diff --git a/gcc/modulo-sched.c b/gcc/modulo-sched.c
index 7ba3ddb..0e1cff4 100644
--- a/gcc/modulo-sched.c
+++ b/gcc/modulo-sched.c
@@ -1166,7 +1166,7 @@ generate_prolog_epilog (partial_schedule_ptr ps, struct loop *loop,
   /* Put the prolog on the entry edge.  */
   e = loop_preheader_edge (loop);
   split_edge_and_insert (e, get_insns ());
-  if (!flag_resched_modulo_sched)
+  if (!GCC_OPTION (flag_resched_modulo_sched))
     e->dest->flags |= BB_DISABLE_SCHEDULE;
 
   end_sequence ();
@@ -1181,7 +1181,7 @@ generate_prolog_epilog (partial_schedule_ptr ps, struct loop *loop,
   gcc_assert (single_exit (loop));
   e = single_exit (loop);
   split_edge_and_insert (e, get_insns ());
-  if (!flag_resched_modulo_sched)
+  if (!GCC_OPTION (flag_resched_modulo_sched))
     e->dest->flags |= BB_DISABLE_SCHEDULE;
 
   end_sequence ();
@@ -1447,7 +1447,7 @@ sms_schedule (void)
 	    {
 	      dump_insn_location (tail);
 	      fprintf (dump_file, "\nSMS single-bb-loop\n");
-	      if (profile_info && flag_branch_probabilities)
+	      if (profile_info && GCC_OPTION (flag_branch_probabilities))
 	    	{
 	      	  fprintf (dump_file, "SMS loop-count ");
 	      	  fprintf (dump_file, HOST_WIDEST_INT_PRINT_DEC,
@@ -1568,7 +1568,7 @@ sms_schedule (void)
 	{
 	  dump_insn_location (tail);
 	  fprintf (dump_file, "\nSMS single-bb-loop\n");
-	  if (profile_info && flag_branch_probabilities)
+	  if (profile_info && GCC_OPTION (flag_branch_probabilities))
 	    {
 	      fprintf (dump_file, "SMS loop-count ");
 	      fprintf (dump_file, HOST_WIDEST_INT_PRINT_DEC,
@@ -1656,7 +1656,7 @@ sms_schedule (void)
 	     we let the scheduling passes do the job in this case.  */
 	  if (stage_count < PARAM_VALUE (PARAM_SMS_MIN_SC)
 	      || (count_init && (loop_count <= stage_count))
-	      || (flag_branch_probabilities && (trip_count <= stage_count)))
+	      || (GCC_OPTION (flag_branch_probabilities) && (trip_count <= stage_count)))
 	    {
 	      if (dump_file)
 		{
@@ -1739,7 +1739,7 @@ sms_schedule (void)
 
           /* Mark this loop as software pipelined so the later
 	     scheduling passes don't touch it.  */
-	  if (! flag_resched_modulo_sched)
+	  if (! GCC_OPTION (flag_resched_modulo_sched))
 	    mark_loop_unsched (loop);
 	  
 	  /* The life-info is not valid any more.  */
@@ -3326,7 +3326,7 @@ rotate_partial_schedule (partial_schedule_ptr ps, int start_cycle)
 static bool
 gate_handle_sms (void)
 {
-  return (optimize > 0 && flag_modulo_sched);
+  return (GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_modulo_sched));
 }
 
 
diff --git a/gcc/objc/objc-act.c b/gcc/objc/objc-act.c
index cb0b5ac..806d314 100644
--- a/gcc/objc/objc-act.c
+++ b/gcc/objc/objc-act.c
@@ -374,7 +374,7 @@ objc_init (void)
      immediately (producing no file), and the second time it compiles
      an empty file.  This checks, as a side effect, that compiling an
      empty file produces no assembler output.  */
-  if (print_struct_values && !flag_compare_debug)
+  if (print_struct_values && !GCC_OPTION (flag_compare_debug))
     generate_struct_by_value_array ();
 
   /* Set up stuff used by FE parser and all runtimes.  */
@@ -383,9 +383,9 @@ objc_init (void)
   hash_init ();
   objc_encoding_init ();
   /* ... and then check flags and set-up for the selected runtime ... */
-  if (flag_next_runtime && flag_objc_abi >= 2)
+  if (GCC_OPTION (flag_next_runtime) && GCC_OPTION (flag_objc_abi) >= 2)
     ok = objc_next_runtime_abi_02_init (&runtime);
-  else if (flag_next_runtime)
+  else if (GCC_OPTION (flag_next_runtime))
     ok = objc_next_runtime_abi_01_init (&runtime);
   else
     ok = objc_gnu_runtime_abi_01_init (&runtime);
@@ -416,7 +416,7 @@ objc_write_global_declarations (void)
       objc_implementation_context = NULL_TREE;
     }
 
-  if (warn_selector)
+  if (GCC_OPTION (warn_selector))
     {
       objc_map_iterator_t i;
 
@@ -436,14 +436,14 @@ objc_write_global_declarations (void)
 
   /* Finalize Objective-C runtime data.  No need to generate tables
      and code if only checking syntax, or if generating a PCH file.  */
-  if (!flag_syntax_only && !pch_file)
+  if (!GCC_OPTION (flag_syntax_only) && !pch_file)
     {
       location_t saved_location;
 
       /* If gen_declaration desired, open the output file.  */
-      if (flag_gen_declaration)
+      if (GCC_OPTION (flag_gen_declaration))
 	{
-	  char * const dumpname = concat (dump_base_name, ".decl", NULL);
+	  char * const dumpname = concat (GCC_OPTION (dump_base_name), ".decl", NULL);
 	  gen_declaration_file = fopen (dumpname, "w");
 	  if (gen_declaration_file == 0)
 	    fatal_error ("can%'t open %s: %m", dumpname);
@@ -562,7 +562,7 @@ void
 objc_start_class_interface (tree klass, tree super_class,
 			    tree protos, tree attributes)
 {
-  if (flag_objc1_only && attributes)
+  if (GCC_OPTION (flag_objc1_only) && attributes)
     error_at (input_location, "class attributes are not available in Objective-C 1.0");
 
   objc_interface_context
@@ -577,7 +577,7 @@ objc_start_category_interface (tree klass, tree categ,
 {
   if (attributes)
     {
-      if (flag_objc1_only)
+      if (GCC_OPTION (flag_objc1_only))
 	error_at (input_location, "category attributes are not available in Objective-C 1.0");
       else
 	warning_at (input_location, OPT_Wattributes,
@@ -586,7 +586,7 @@ objc_start_category_interface (tree klass, tree categ,
     }
   if (categ == NULL_TREE)
     {
-      if (flag_objc1_only)
+      if (GCC_OPTION (flag_objc1_only))
 	error_at (input_location, "class extensions are not available in Objective-C 1.0");
       else
 	{
@@ -615,7 +615,7 @@ objc_start_category_interface (tree klass, tree categ,
 void
 objc_start_protocol (tree name, tree protos, tree attributes)
 {
-  if (flag_objc1_only && attributes)
+  if (GCC_OPTION (flag_objc1_only) && attributes)
     error_at (input_location, "protocol attributes are not available in Objective-C 1.0");
 
   objc_interface_context
@@ -670,7 +670,7 @@ void
 objc_finish_implementation (void)
 {
 #ifdef OBJCPLUS
-  if (flag_objc_call_cxx_cdtors)
+  if (GCC_OPTION (flag_objc_call_cxx_cdtors))
     objc_generate_cxx_cdtors ();
 #endif
 
@@ -689,7 +689,7 @@ objc_set_visibility (objc_ivar_visibility_kind visibility)
 {
   if (visibility == OBJC_IVAR_VIS_PACKAGE)
     {
-      if (flag_objc1_only)
+      if (GCC_OPTION (flag_objc1_only))
 	error ("%<@package%> is not available in Objective-C 1.0");
       else
 	warning (0, "%<@package%> presently has the same effect as %<@public%>");
@@ -700,7 +700,7 @@ objc_set_visibility (objc_ivar_visibility_kind visibility)
 void
 objc_set_method_opt (bool optional)
 {
-  if (flag_objc1_only)
+  if (GCC_OPTION (flag_objc1_only))
     {
       if (optional)
 	error_at (input_location, "%<@optional%> is not available in Objective-C 1.0");
@@ -821,7 +821,7 @@ objc_add_property_declaration (location_t location, tree decl,
   objc_property_assign_semantics property_assign_semantics = OBJC_PROPERTY_ASSIGN;
   bool property_extension_in_class_extension = false;
 
-  if (flag_objc1_only)
+  if (GCC_OPTION (flag_objc1_only))
     error_at (input_location, "%<@property%> is not available in Objective-C 1.0");
 
   if (parsed_property_readonly && parsed_property_readwrite)
@@ -922,7 +922,7 @@ objc_add_property_declaration (location_t location, tree decl,
      "POD".  */
 
   /* Implement -Wproperty-assign-default (which is enabled by default).  */
-  if (warn_property_assign_default
+  if (GCC_OPTION (warn_property_assign_default)
       /* If garbage collection is not being used, then 'assign' is
 	 valid for objects (and typically used for delegates) but it
 	 is wrong in most cases (since most objects need to be
@@ -932,7 +932,7 @@ objc_add_property_declaration (location_t location, tree decl,
       /* Read-only properties are never assigned, so the assignment
 	 semantics do not matter in that case.  */
       && !property_readonly
-      && !flag_objc_gc)
+      && !GCC_OPTION (flag_objc_gc))
     {
       /* Please note that it would make sense to default to 'assign'
 	 for non-{Objective-C objects}, and to 'retain' for
@@ -1351,7 +1351,7 @@ objc_maybe_build_component_ref (tree object, tree property_ident)
 
   /* If we are in Objective-C 1.0 mode, dot-syntax and properties are
      not available.  */
-  if (flag_objc1_only)
+  if (GCC_OPTION (flag_objc1_only))
     return NULL_TREE;
 
   /* Try to determine if 'object' is an Objective-C object or not.  If
@@ -1633,7 +1633,7 @@ objc_build_class_component_ref (tree class_name, tree property_ident)
   tree x = NULL_TREE;
   tree object, rtype;
 
-  if (flag_objc1_only)
+  if (GCC_OPTION (flag_objc1_only))
     error_at (input_location, "the dot syntax is not available in Objective-C 1.0");
 
   if (class_name == NULL_TREE || class_name == error_mark_node
@@ -2002,7 +2002,7 @@ objc_add_method_declaration (bool is_class_method, tree decl, tree attributes)
       fatal_error ("method declaration not in @interface context");
     }
 
-  if (flag_objc1_only && attributes)
+  if (GCC_OPTION (flag_objc1_only) && attributes)
     error_at (input_location, "method attributes are not available in Objective-C 1.0");
 
   objc_decl_method_attributes (&decl, attributes, 0);
@@ -2905,12 +2905,12 @@ static void
 synth_module_prologue (void)
 {
   tree type;
-  enum debug_info_type save_write_symbols = write_symbols;
+  enum debug_info_type save_write_symbols = GCC_OPTION (write_symbols);
   const struct gcc_debug_hooks *const save_hooks = debug_hooks;
 
   /* Suppress outputting debug symbols, because
      dbxout_init hasn't been called yet.  */
-  write_symbols = NO_DEBUG;
+  GCC_OPTION (write_symbols) = NO_DEBUG;
   debug_hooks = &do_nothing_debug_hooks;
 
 #ifdef OBJCPLUS
@@ -2999,7 +2999,7 @@ synth_module_prologue (void)
   pop_lang_context ();
 #endif
 
-  write_symbols = save_write_symbols;
+  GCC_OPTION (write_symbols) = save_write_symbols;
   debug_hooks = save_hooks;
 }
 
@@ -3136,7 +3136,7 @@ objc_build_string_object (tree string)
      literal.  On Darwin (Mac OS X), for example, we may wish to obtain a
      constant CFString reference instead.
      At present, this is only supported for the NeXT runtime.  */
-  if (flag_next_runtime
+  if (GCC_OPTION (flag_next_runtime)
       && targetcm.objc_construct_string_object)
     {
       tree constructor = (*targetcm.objc_construct_string_object) (string);
@@ -3540,7 +3540,7 @@ objc_build_ivar_assignment (tree outervar, tree lhs, tree rhs)
     = objc_substitute_decl
       (lhs, outervar, convert (TREE_TYPE (outervar), integer_zero_node));
   tree func
-    = (flag_objc_direct_dispatch
+    = (GCC_OPTION (flag_objc_direct_dispatch)
        ? objc_assign_ivar_fast_decl
        : objc_assign_ivar_decl);
 
@@ -3627,7 +3627,7 @@ objc_generate_write_barrier (tree lhs, enum tree_code modifycode, tree rhs)
 
   /* This function is currently only used with the next runtime with
      garbage collection enabled (-fobjc-gc).  */
-  gcc_assert (flag_next_runtime);
+  gcc_assert (GCC_OPTION (flag_next_runtime));
 
   /* See if we have any lhs casts, and strip them out.  NB: The lvalue casts
      will have been transformed to the form '*(type *)&expr'.  */
@@ -3663,7 +3663,7 @@ objc_generate_write_barrier (tree lhs, enum tree_code modifycode, tree rhs)
       if (modifycode != NOP_EXPR)
         goto invalid_pointer_arithmetic;
 
-      if (warn_assign_intercept)
+      if (GCC_OPTION (warn_assign_intercept))
 	warning (0, "strong-cast assignment has been intercepted");
 
       result = objc_build_strong_cast_assignment (lhs, rhs);
@@ -3705,7 +3705,7 @@ objc_generate_write_barrier (tree lhs, enum tree_code modifycode, tree rhs)
 	 suggest_cast:
 	  if (modifycode == NOP_EXPR)
 	    {
-	      if (warn_assign_intercept)
+	      if (GCC_OPTION (warn_assign_intercept))
 		warning (0, "strong-cast may possibly be needed");
 	    }
 
@@ -3715,7 +3715,7 @@ objc_generate_write_barrier (tree lhs, enum tree_code modifycode, tree rhs)
       if (modifycode != NOP_EXPR)
         goto invalid_pointer_arithmetic;
 
-      if (warn_assign_intercept)
+      if (GCC_OPTION (warn_assign_intercept))
 	warning (0, "instance variable assignment has been intercepted");
 
       result = objc_build_ivar_assignment (outer, lhs, rhs);
@@ -3740,7 +3740,7 @@ objc_generate_write_barrier (tree lhs, enum tree_code modifycode, tree rhs)
 	  goto exit_point;
 	}
 
-      if (warn_assign_intercept)
+      if (GCC_OPTION (warn_assign_intercept))
 	warning (0, "global/static variable assignment has been intercepted");
 
       result = objc_build_global_assignment (lhs, rhs);
@@ -4098,7 +4098,7 @@ objc_maybe_warn_exceptions (location_t loc)
      explicitly.  On other platforms, at the moment -fobjc-exceptions
      triggers -fexceptions which again is required for exceptions to
      work.  */
-  if (!flag_objc_exceptions)
+  if (!GCC_OPTION (flag_objc_exceptions))
     {
       /* Warn only once per compilation unit.  */
       static bool warned = false;
@@ -4129,7 +4129,7 @@ objc_begin_try_stmt (location_t try_locus, tree body)
   /* Collect the list of local variables.  We'll mark them as volatile
      at the end of compilation of this function to prevent them being
      clobbered by setjmp/longjmp.  */
-  if (flag_objc_sjlj_exceptions)
+  if (GCC_OPTION (flag_objc_sjlj_exceptions))
     objc_mark_locals_volatile (NULL);
 }
 
@@ -4413,7 +4413,7 @@ build_private_template (tree klass)
 
       /* Set the TREE_USED bit for this struct, so that stab generator
 	 can emit stabs for this struct type.  */
-      if (flag_debug_only_used_symbols && TYPE_STUB_DECL (record))
+      if (GCC_OPTION (flag_debug_only_used_symbols) && TYPE_STUB_DECL (record))
 	TREE_USED (TYPE_STUB_DECL (record)) = 1;
 
       /* Copy the attributes from the class to the type.  */
@@ -4701,7 +4701,7 @@ objc_build_keyword_decl (tree key_name, tree arg_type,
 {
   tree keyword_decl;
 
-  if (flag_objc1_only && attributes)
+  if (GCC_OPTION (flag_objc1_only) && attributes)
     error_at (input_location, "method argument attributes are not available in Objective-C 1.0");
 
   /* If no type is specified, default to "id".  */
@@ -5070,7 +5070,7 @@ check_duplicates (tree method, int methods, int is_class)
      -Wno-strict-selector-match is specified, we shall not complain if
      the differences are solely among types with identical size and
      alignment.  */
-  if (!warn_strict_selector_match)
+  if (!GCC_OPTION (warn_strict_selector_match))
     {
       for (i = 0; i < (size_t) TREE_VEC_LENGTH (method); i++)
 	if (!comp_proto_with_proto (first_method, TREE_VEC_ELT (method, i), 0))
@@ -5708,7 +5708,7 @@ objc_build_selector_expr (location_t loc, tree selnamelist)
 
   /* If we are required to check @selector() expressions as they
      are found, check that the selector has been declared.  */
-  if (warn_undeclared_selector)
+  if (GCC_OPTION (warn_undeclared_selector))
     {
       /* Look the selector up in the list of all known class and
          instance methods (up to this line) to check that the selector
@@ -6244,7 +6244,7 @@ add_instance_variable (tree klass, objc_ivar_visibility_kind visibility,
     {
       tree type_name = OBJC_TYPE_NAME (field_type);
 
-      if (flag_objc_call_cxx_cdtors)
+      if (GCC_OPTION (flag_objc_call_cxx_cdtors))
         {
 	  /* Since the ObjC runtime will be calling the constructors and
 	     destructors for us, the only thing we can't handle is the lack
@@ -6695,7 +6695,7 @@ check_protocol (tree p, const char *type, tree name)
       int f1, f2;
 
       /* Ensure that all protocols have bodies!  */
-      if (warn_protocol)
+      if (GCC_OPTION (warn_protocol))
 	{
 	  f1 = check_methods (PROTOCOL_CLS_METHODS (p),
 			      objc_implementation_context,
@@ -7700,7 +7700,7 @@ objc_add_synthesize_declaration (location_t location, tree property_and_ivar_lis
 {
   tree interface, chain;
 
-  if (flag_objc1_only)
+  if (GCC_OPTION (flag_objc1_only))
     error_at (input_location, "%<@synthesize%> is not available in Objective-C 1.0");
 
   if (property_and_ivar_list == error_mark_node)
@@ -7809,7 +7809,7 @@ objc_add_dynamic_declaration (location_t location, tree property_list)
 {
   tree interface, chain;
 
-  if (flag_objc1_only)
+  if (GCC_OPTION (flag_objc1_only))
     error_at (input_location, "%<@dynamic%> is not available in Objective-C 1.0");
 
   if (property_list == error_mark_node)
@@ -9666,7 +9666,7 @@ objc_finish_foreach_loop (location_t location, tree object_expression, tree coll
   tree t;
   int i;
 
-  if (flag_objc1_only)
+  if (GCC_OPTION (flag_objc1_only))
     error_at (location, "fast enumeration is not available in Objective-C 1.0");
 
   if (object_expression == error_mark_node)
diff --git a/gcc/objc/objc-encoding.c b/gcc/objc/objc-encoding.c
index 70c2a68..14911d5 100644
--- a/gcc/objc/objc-encoding.c
+++ b/gcc/objc/objc-encoding.c
@@ -256,7 +256,7 @@ encode_pointer (tree type, int curtype, int format)
 {
   tree pointer_to = TREE_TYPE (type);
 
-  if (flag_next_runtime)
+  if (GCC_OPTION (flag_next_runtime))
     {
       /* This code is used to be compatible with gcc-3.3.  */
       /* For historical/compatibility reasons, the read-only qualifier
@@ -324,7 +324,7 @@ encode_pointer (tree type, int curtype, int format)
 	 other pointers to char are encoded as *.   */
       if (strcmp (IDENTIFIER_POINTER (pname), "BOOL"))
 	{
-	  if (!flag_next_runtime)
+	  if (!GCC_OPTION (flag_next_runtime))
 	    {
 	      /* The NeXT runtime adds the 'r' before getting here.  */
 
@@ -491,7 +491,7 @@ encode_aggregate_within (tree type, int curtype, int format, int left,
   bool inline_contents = false;
   bool pointed_to = false;
 
-  if (flag_next_runtime)
+  if (GCC_OPTION (flag_next_runtime))
     {
       if (ob_size > 0  &&  *(obstack_next_free (&util_obstack) - 1) == '^')
 	pointed_to = true;
@@ -603,7 +603,7 @@ encode_type (tree type, int curtype, int format)
   if (type == error_mark_node)
     return;
 
-  if (!flag_next_runtime)
+  if (!GCC_OPTION (flag_next_runtime))
     {
       if (TYPE_READONLY (type))
 	obstack_1grow (&util_obstack, 'r');
@@ -612,7 +612,7 @@ encode_type (tree type, int curtype, int format)
   switch (code)
     {
     case ENUMERAL_TYPE:
-      if (flag_next_runtime)
+      if (GCC_OPTION (flag_next_runtime))
 	{
 	  /* Kludge for backwards-compatibility with gcc-3.3: enums
 	     are always encoded as 'i' no matter what type they
@@ -632,7 +632,7 @@ encode_type (tree type, int curtype, int format)
 	  case 32:
 	    {
 	      tree int_type = type;
-	      if (flag_next_runtime)
+	      if (GCC_OPTION (flag_next_runtime))
 		{
 		  /* Another legacy kludge for compatibility with
 		     gcc-3.3: 32-bit longs are encoded as 'l' or 'L',
@@ -723,7 +723,7 @@ encode_type (tree type, int curtype, int format)
       break;
     }
 
-  if (flag_next_runtime)
+  if (GCC_OPTION (flag_next_runtime))
     {
       /* Super-kludge.  Some ObjC qualifier and type combinations need
 	 to be rearranged for compatibility with gcc-3.3.  */
@@ -824,7 +824,7 @@ encode_field (tree field_decl, int curtype, int format)
     {
       int size = tree_to_uhwi (DECL_SIZE (field_decl));
 
-      if (flag_next_runtime)
+      if (GCC_OPTION (flag_next_runtime))
 	encode_next_bitfield (size);
       else
 	encode_gnu_bitfield (int_bit_position (field_decl),
